//
//  mdlWorkOrderPart.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlWorkOrderPart: Model, Content {
    static let schema = "workOrderPart"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Parent(key: "partId") var part: mdlPart
    @Parent(key: "workOrderSegmentId") var segment: mdlWorkOrderSegment
    
    @Field(key: "refDocNumber") var refdocnumber: String?
    @Field(key: "qtyIssued") var qtyissued: Decimal?
    @Field(key: "qtyReturned") var qtyreturned: Decimal?
    
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         partid: Int,
         segment: Int,
         refdocnumber: String? = nil,
         qtyissued: Decimal? = nil,
         qtyreturned: Decimal? = nil,
         createuserid: Int? = nil,
         updateuserid: Int? = nil
    ) {
        self.id = id
        self.$part.$id.value = partid
        self.$segment.$id.value = segment
        self.refdocnumber = refdocnumber
        self.qtyissued = qtyissued
        self.qtyreturned = qtyreturned
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlWorkOrderPart{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("workOrderParts")
                .field("id", .int, .identifier(auto: true))
                .field("partId", .int, .references("part", "id"))
                .field("segmentId", .int, .references("xWorkOrderSegment", "id"))
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("workOrderParts").delete()
        }
    }
    struct Mod1: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("workOrderParts")
                .field("refDocNumber", .string)
                .field("qtyIssued", .double)
                .field("qtyReturned", .double)
                .update()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("workOrderParts")
                .deleteField("refDocNumber")
                .deleteField("qtyIssued")
                .deleteField("qtyReturned")
                .update()
        }
    }
    struct Mod2: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("workOrderParts")
                .deleteField("segmentId")
                .field("workOrderSegmentId", .int, .references("workOrderSegment", "id"))
                .update()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("workOrderParts")
                .deleteField("workOrderSegmentId")
                .field("segmentId", .int, .references("xWorkOrderSegment", "id"))
                .update()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlWorkOrderPart>{
        
        let query = mdlWorkOrderPart.query(on: req.db)
            .with(\.$part)
            .with(\.$segment)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

